<?php
/**
 *  Devices API
 */

const BASE_DIR = "/usr/local/mgportal/";
const BIN_DIR = "bin/";
const CONFIG_DIR = "conf.d/";
const CONFIG_FILE = "mgportal.conf";
const API_LOG_FILE = "portal_api";

require_once("HTTP.php");
require_once("api-base.php");

require_once(BASE_DIR . BIN_DIR . 'config.php');
require_once(BASE_DIR . BIN_DIR . 'logger.php');
require_once(BASE_DIR . BIN_DIR . 'commands.php');
require_once(BASE_DIR . BIN_DIR . "database.php");

$Log = new Logger(Logger::DEBUG);
$Config = new Configuration(BASE_DIR . CONFIG_DIR, CONFIG_FILE, "server");
$Config->load_configuration();
$Log->setLogLevel($Config->getLogLevel());
$Log->setLogFile(API_LOG_FILE);
$http = new HTTP($Config->getDeviceAllowance());

class Capacity extends BaseAPI {
    public function __construct($conn, $Log) {
        parent::__construct($conn, $Log);
    }
    
    public function get($which, $filter) {
    }
    
    public function post($data, $hasSupport) {
        $asset_tag = $data['asset_tag'];
        $command = $data["meta_command"];
        $timestamp = $data["meta_timestamp"];
        $data["has_support_contract"] = $hasSupport;
        $msg = sprintf("Message: Device ID is %s, Command is %s", $asset_tag, $command);
        $this->Log->logInfo($msg);
        $commands = new Commands($command, $this->conn);
        $commands->run($timestamp, $asset_tag, $data);
        return true;
    }

};

$authMessage = HTTP::UNAUTHENTICATED_MESSAGE;
if ($http->isAuthenticated($authMessage)) {
    $db = new Database();
    $conn = $db->connect();
    if ($conn !== false) {
        switch ($http->getMethod()) {
            case 'post':
                $capacity = new Capacity($conn, $Log);
                $result = $capacity->post($http->getData(), $http->getDeviceSupportStatus());
                $Log->writeVariable($result);
                $db->closeConnection();
                if ($result !== false) {
                    $http->buildSuccess($result, "POST");
                } else {
                    $Log->logError("Error logging capacity");
                    $http->buildFailure(false, "Error logging capacity");;
                }
                break;
        }
        $db->closeConnection();
    } else {
        $Log->logError("Server error connecting to database");
        $http->buildFailure(false, "Server error connecting to database");
    }
} else {
    $message = $http->getError();
    $message = $message == "" ? HTTP::UNAUTHENTICATED_MESSAGE : $message;
    $Log->logError($message);
    $http->buildFailure(false, $message);
}

?>